<template>
  <div class="ob-draft__risks">
    <div class="ob-draft__risks-row">
      <h5 class="ob-draft__risks-title">Продолжительность автомобильной перевозки</h5>
      <p :class="`risk-${risks.durationInterval.toLowerCase()}`">{{ duration }}</p>
    </div>
    <div class="ob-draft__risks-row">
      <h5 class="ob-draft__risks-title">Риск хищения</h5>
      <p :class="`risk-${risks.cargoLossProbability.toLowerCase()}`">{{ lossProbability }}</p>
    </div>
    <div class="ob-draft__risks-row">
      <h5 class="ob-draft__risks-title">Категория стоимости</h5>
      <p :class="`risk-${risks.costInterval.toLowerCase()}`" v-html="costCategory"></p>
    </div>
    <div class="ob-draft__risks-row">
      <h5 class="ob-draft__risks-title">Группа риска заказа</h5>
      <p class="ob-draft__risk-group">
        <i :class="['icon', getRiskClass(risks.riskColor)]" />
        <span>Группа риска {{ getNumberRisk(risks.riskColor) }}</span>
      </p>
    </div>
    <div class="ob-draft__risks-row">
      <h5 class="ob-draft__risks-title">Подходящие исполнители</h5>
      <div class="ob-draft__risk-group">
        <div class="ob-draft__risk-icons">
          <i
            v-for="(carrier, index) in carrierColors"
            :key="carrier"
            :class="['icon', $options.riskColorsMap[carrier]]"
            :style="`z-index: ${carrierColors.length - index};`"
          ></i>
        </div>
        <span>Группа риска {{ carrierRisks }}</span>
      </div>
    </div>
  </div>
</template>

<script>
import { getRiskClass } from "@/helpers/risks";
import { getNumberRisk } from "@/helpers/risks";
import { sortRisks } from "@/helpers/risks";
import { formatNumber } from "common-components/src/helpers/common";
export default {
  name: "draftRisks",

  props: {
    risks: {
      type: Object,
      required: true,
    },

    errors: {
      type: Array,
      default: () => [],
    },
  },

  riskColorsMap: {
    GREEN: "risk-1-blue",
    BLUE: "risk-2-green",
    YELLOW: "risk-3-yellow",
    ORANGE: "risk-4-orange",
    RED: "risk-5-red",
    BLACK: "risk-6-black",
  },

  computed: {
    carrierColors() {
      return this.risks.acceptedCarrierColors
        ? this.sortRisks({
            data: this.risks.acceptedCarrierColors,
          })
        : [];
    },

    carrierRisks() {
      const arr = this.carrierColors.map((item) => {
        return this.getNumberRisk(item);
      });
      return arr.length === 1
        ? `${arr[0]}`
        : `${arr[0]}-${arr[arr.length - 1]}`;
    },

    lossProbability() {
      const levelMap = {
        HIGH: "Высокий",
        MEDIUM: "Средний",
        LOW: "Низкий",
      };
      return levelMap[this.risks.cargoLossProbability] || "—";
    },

    duration() {
      const durationMap = {
        HIGH: "Высокая",
        MEDIUM: "Средняя",
        LOW: "Короткая",
      };
      return this.risks.durationInterval
        ? `${durationMap[this.risks.durationInterval]}`
        : "—";
    },

    costCategory() {
      const costMap = {
        HIGH: `Высокая <span>(более ${formatNumber(
          this.risks.costIntervalMin / 100
        )} ₽)</span>`,
        MEDIUM: `Средняя <span>(от ${formatNumber(
          this.risks.costIntervalMin / 100
        )} ₽ до ${formatNumber(this.risks.costIntervalMax / 100)} ₽)</span>`,
        LOW: `Низкая <span>(менее ${formatNumber(
          this.risks.costIntervalMax / 100
        )} ₽)</span>`,
      };
      return this.risks.costInterval ? costMap[this.risks.costInterval] : "—";
    },
  },

  methods: {
    getRiskClass,
    getNumberRisk,
    sortRisks,

    getDuration(duration) {
      const fm = [
        Math.floor(duration / (3600 * 24)),
        Math.ceil((duration % (3600 * 24)) / 3600),
      ];
      return fm
        .map((v, i) => {
          if (v) {
            if (i === 0) {
              v = `${v} д`;
            } else if (i === 1) {
              v = `${v} ч`;
            } else if (i === 2) {
              v = `${v} м`;
            } else if (i === 3) {
              v = `${v} сек`;
            }
            return v;
          }
        })
        .join(" ");
    },
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.ob-draft__risks-row {
  margin-bottom: 10px;

  span {
    color: $gray-slate;
  }

  ::v-deep {
    span {
      color: $gray-slate;
    }
  }
}

.ob-draft__risks-title {
  @include font-mixin(12px, 12px, 400, $gray-slate);
}

.ob-draft__risk-group {
  display: flex;
  align-items: center;

  .icon {
    font-size: 18px;
  }

  span {
    margin-left: 5px;
  }
}

.risk-low {
  color: $Green-700;
}

.risk-medium {
  color: $diamond-orange-yellow;
}

.risk-high {
  color: $color-error;
}

.ob-draft__risk-icons {
  display: flex;
  flex-direction: row-reverse;
}
</style>